package com.zhongzheng.modules.user.service;

import com.zhongzheng.modules.user.bo.*;
import com.zhongzheng.modules.user.domain.User;
import com.zhongzheng.modules.user.vo.RanKingUser;
import com.zhongzheng.modules.user.vo.UserStudyRecordVo;
import com.zhongzheng.modules.user.vo.UserVo;
import com.baomidou.mybatisplus.extension.service.IService;

import java.math.BigDecimal;
import java.util.Collection;
import java.util.List;

/**
 * 用户Service接口
 *
 * @author change
 * @date 2021-05-25
 */
public interface IUserService extends IService<User> {
	/**
	 * 查询单个
	 * @return
	 */
	UserVo queryById(Long userId);


	User queryByUnionId(String unionId);

	User queryByAccount(String userAccount);
	/**
	 * 查询列表
	 */
	List<UserVo> queryList(UserQueryBo bo);

	List<UserVo> selectList(UserQueryBo bo);

	List<UserStudyRecordVo> selectStudyRecordList(UserStudyRecordQueryBo bo);

	/**
	 * 根据新增业务对象插入用户
	 * @param bo 用户新增业务对象
	 * @return
	 */
	Boolean insertByAddBo(UserAddBo bo);

	/**
	 * 根据编辑业务对象修改用户
	 * @param bo 用户编辑业务对象
	 * @return
	 */
	Boolean updateByEditBo(UserEditBo bo) throws IllegalAccessException;

	/**
	 * 校验并删除数据
	 * @param ids 主键集合
	 * @param isValid 是否校验,true-删除前校验,false-不校验
	 * @return
	 */
	Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid);


	Integer getCollectTotal(Long userId);

	RanKingUser rankingList(RanKingUserQuery bo);

	Integer getRank(Long userId);

    Integer getIssue(Long userId);

	BigDecimal getMoney(Long userId);

    Integer selectUserNum(Integer grade);

}
